Index: proppage.cc
===================================================================
RCS file: proppage.cc
diff -N proppage.cc
--- /dev/null	Tue May  5 13:32:27 1998
+++ proppage.cc	Thu Dec 20 04:36:02 2001
@@ -0,0 +1,226 @@
+/*
+ * Copyright (c) 2001, Gary R. Van Sickle.
+ *
+ *     This program is free software; you can redistribute it and/or modify
+ *     it under the terms of the GNU General Public License as published by
+ *     the Free Software Foundation; either version 2 of the License, or
+ *     (at your option) any later version.
+ *
+ *     A copy of the GNU General Public License can be found at
+ *     http://www.gnu.org/
+ *
+ * Written by Gary R. Van Sickle <g.r.vansickle@worldnet.att.net>
+ *
+ */
+
+// This is the implementation of the PropertyPage class.  It works closely with the
+// PropSheet class to implement a single page of the property sheet.
+
+#include "proppage.h"
+#include "propsheet.h"
+#include "win32.h"
+
+bool
+  PropertyPage::DoOnceForSheet =
+  true;
+
+PropertyPage::PropertyPage ()
+{
+  proc = NULL;
+  cmdproc = NULL;
+  IsFirst = false;
+  IsLast = false;
+}
+
+PropertyPage::~PropertyPage ()
+{
+}
+
+bool
+PropertyPage::Create (int TemplateID)
+{
+  return Create (NULL, NULL, TemplateID);
+}
+
+bool
+PropertyPage::Create (DLGPROC dlgproc, int TemplateID)
+{
+  return Create (dlgproc, NULL, TemplateID);
+}
+
+bool
+PropertyPage::Create (DLGPROC dlgproc,
+		      BOOL (*cproc) (HWND h, int id, HWND hwndctl, UINT code),
+		      int TemplateID)
+{
+  psp.dwSize = sizeof (PROPSHEETPAGE);
+  psp.dwFlags = 0;
+  psp.hInstance = GetInstance ();
+  psp.pfnDlgProc = FirstDialogProcReflector;
+  psp.pszTemplate = (LPCSTR) TemplateID;
+  psp.lParam = (LPARAM) this;
+  psp.pfnCallback = NULL;
+
+  proc = dlgproc;
+  cmdproc = cproc;
+
+  return true;
+}
+
+BOOL CALLBACK
+PropertyPage::FirstDialogProcReflector (HWND hwnd, UINT message,
+					WPARAM wParam, LPARAM lParam)
+{
+  PropertyPage *This;
+
+  if (message != WM_INITDIALOG)
+    {
+      // Don't handle anything until we get a WM_INITDIALOG message, which
+      // will have our this pointer with it.
+      return FALSE;
+    }
+
+  This = (PropertyPage *) (((PROPSHEETPAGE *) lParam)->lParam);
+
+  SetWindowLong (hwnd, DWL_USER, (DWORD) This);
+  SetWindowLong (hwnd, DWL_DLGPROC, (DWORD) DialogProcReflector);
+
+  This->SetHWND (hwnd);
+  return This->DialogProc (message, wParam, lParam);
+}
+
+BOOL CALLBACK
+PropertyPage::DialogProcReflector (HWND hwnd, UINT message, WPARAM wParam,
+				   LPARAM lParam)
+{
+  PropertyPage *This;
+
+  This = (PropertyPage *) GetWindowLong (hwnd, DWL_USER);
+
+  return This->DialogProc (message, wParam, lParam);
+}
+
+BOOL CALLBACK
+PropertyPage::DialogProc (UINT message, WPARAM wParam, LPARAM lParam)
+{
+  if (proc != NULL)
+    {
+      proc (GetHWND (), message, wParam, lParam);
+    }
+
+  bool retval;
+
+  switch (message)
+    {
+    case WM_INITDIALOG:
+      {
+	OnInit ();
+	// TRUE = Set focus to default control (in wParam).
+	return TRUE;
+	break;
+      }
+    case WM_NOTIFY:
+      switch (((NMHDR FAR *) lParam)->code)
+	{
+	case PSN_APPLY:
+	  SetWindowLong (GetHWND (), DWL_MSGRESULT, PSNRET_NOERROR);
+	  return TRUE;
+	  break;
+	case PSN_SETACTIVE:
+	  {
+	    if (DoOnceForSheet)
+	      {
+		// Tell our parent PropSheet what its own HWND is.
+		GetOwner ()->SetHWNDFromPage (((NMHDR FAR *) lParam)->
+					      hwndFrom);
+		GetOwner ()->CenterWindow ();
+		// Add a minimize box to the parent property sheet.  We do this here
+		// instead of in the sheet class mainly because it will work with either
+		// modal or modeless sheets.
+		LONG style =::GetWindowLong (((NMHDR FAR *) lParam)->hwndFrom,
+					     GWL_STYLE);
+		::SetWindowLong (((NMHDR FAR *) lParam)->hwndFrom, GWL_STYLE,
+				 style | WS_MINIMIZEBOX);
+		DoOnceForSheet = false;
+	      }
+
+	    // Set the wizard buttons apropriately
+	    if (IsFirst)
+	      {
+		// Disable "Back" on first page.
+		GetOwner ()->SetButtons (PSWIZB_NEXT);
+		//::PropSheet_SetWizButtons(((NMHDR FAR *) lParam)->hwndFrom, PSWIZB_NEXT);
+	      }
+	    else if (IsLast)
+	      {
+		// Disable "Next", enable "Finish" on last page
+		GetOwner ()->SetButtons (PSWIZB_BACK | PSWIZB_FINISH);
+		//::PropSheet_SetWizButtons(((NMHDR FAR *) lParam)->hwndFrom, PSWIZB_BACK | PSWIZB_FINISH);
+	      }
+	    else
+	      {
+		// Middle page, enable both "Next" and "Back" buttons
+		GetOwner ()->SetButtons (PSWIZB_BACK | PSWIZB_NEXT);
+		//::PropSheet_SetWizButtons(((NMHDR FAR *) lParam)->hwndFrom, PSWIZB_BACK | PSWIZB_NEXT);
+	      }
+
+	    OnActivate ();
+
+	    // 0 == Accept activation, -1 = Don't accept
+	    ::SetWindowLong (GetHWND (), DWL_MSGRESULT, 0);
+	    return TRUE;
+	  }
+	  break;
+	case PSN_KILLACTIVE:
+	  OnDeactivate ();
+	  // FALSE = Allow deactivation
+	  SetWindowLong (GetHWND (), DWL_MSGRESULT, FALSE);
+	  return TRUE;
+	  break;
+	case PSN_WIZNEXT:
+	  {
+	    LONG retval;
+	    retval = OnNext ();
+	    SetWindowLong (GetHWND (), DWL_MSGRESULT, retval);
+	    return TRUE;
+	  }
+	  break;
+	case PSN_WIZBACK:
+	  {
+	    LONG retval;
+	    retval = OnBack ();
+	    SetWindowLong (GetHWND (), DWL_MSGRESULT, retval);
+	    return TRUE;
+	  }
+	  break;
+	case PSN_WIZFINISH:
+	  retval = OnFinish ();
+	  // False = Allow the wizard to finish
+	  SetWindowLong (GetHWND (), DWL_MSGRESULT, FALSE);
+	  return TRUE;
+	  break;
+	default:
+	  // Unrecognized notification
+	  return FALSE;
+	  break;
+	}
+      break;
+    case WM_COMMAND:
+      if (cmdproc != NULL)
+	{
+	  return HANDLE_WM_COMMAND (GetHWND (), wParam, lParam, cmdproc);
+	}
+      break;
+    default:
+      break;
+    }
+
+  if ((message >= WM_APP) && (message < 0xC000))
+    {
+      // It's a private app message
+      return OnMessageApp (message, wParam, lParam);
+    }
+
+  // Wasn't handled
+  return FALSE;
+}
Index: proppage.h
===================================================================
RCS file: proppage.h
diff -N proppage.h
--- /dev/null	Tue May  5 13:32:27 1998
+++ proppage.h	Thu Dec 20 04:36:02 2001
@@ -0,0 +1,117 @@
+#ifndef CINSTALL_PROPPAGE_H
+#define CINSTALL_PROPPAGE_H
+
+/*
+ * Copyright (c) 2001, Gary R. Van Sickle.
+ *
+ *     This program is free software; you can redistribute it and/or modify
+ *     it under the terms of the GNU General Public License as published by
+ *     the Free Software Foundation; either version 2 of the License, or
+ *     (at your option) any later version.
+ *
+ *     A copy of the GNU General Public License can be found at
+ *     http://www.gnu.org/
+ *
+ * Written by Gary R. Van Sickle <g.r.vansickle@worldnet.att.net>
+ *
+ */
+
+// This is the header for the PropertyPage class.  It works closely with the
+// PropSheet class to implement a single page of the property sheet.
+
+
+#include <windows.h>
+#include <prsht.h>
+
+#include "window.h"
+
+class PropSheet;
+
+class PropertyPage:public Window
+{
+  static bool DoOnceForSheet;
+  PROPSHEETPAGE psp;
+  DLGPROC proc;
+    BOOL (*cmdproc) (HWND h, int id, HWND hwndctl, UINT code);
+
+  // The sheet that owns this page.
+  PropSheet *OurSheet;
+
+  // For setting the back/finish buttons properly.
+  bool IsFirst, IsLast;
+
+  static BOOL CALLBACK FirstDialogProcReflector (HWND hwnd, UINT message,
+						 WPARAM wParam,
+						 LPARAM lParam);
+  static BOOL CALLBACK DialogProcReflector (HWND hwnd, UINT message,
+					    WPARAM wParam, LPARAM lParam);
+
+protected:
+    virtual BOOL CALLBACK DialogProc (UINT message, WPARAM wParam,
+				      LPARAM lParam);
+
+public:
+    PropertyPage ();
+    virtual ~ PropertyPage ();
+
+  PROPSHEETPAGE *GetPROPSHEETPAGEPtr ()
+  {
+    return &psp;
+  };
+
+  // FIXME: These should be private and friended to PropSheet.
+  void YouAreBeingAddedToASheet (PropSheet * ps)
+  {
+    OurSheet = ps;
+  };
+  void YouAreFirst ()
+  {
+    IsFirst = true;
+    IsLast = false;
+  };
+  void YouAreLast ()
+  {
+    IsFirst = false;
+    IsLast = true;
+  };
+  void YouAreMiddle ()
+  {
+    IsFirst = false;
+    IsLast = false;
+  };
+
+  virtual bool Create (int TemplateID);
+  virtual bool Create (DLGPROC dlgproc, int TemplateID);
+  virtual bool Create (DLGPROC dlgproc,
+		       BOOL (*cmdproc) (HWND h, int id, HWND hwndctl,
+					UINT code), int TemplateID);
+
+  virtual void OnInit ()
+  {
+  };
+  virtual void OnActivate ()
+  {
+  };
+  virtual void OnDeactivate ()
+  {
+  };
+  virtual long OnNext ()
+  {
+    return 0;
+  };
+  virtual long OnBack ()
+  {
+    return 0;
+  };
+  virtual bool OnFinish ()
+  {
+    return true;
+  };
+
+  PropSheet *GetOwner () const
+  {
+    return OurSheet;
+  };
+};
+
+#endif // CINSTALL_PROPPAGE_H
Index: propsheet.cc
===================================================================
RCS file: propsheet.cc
diff -N propsheet.cc
--- /dev/null	Tue May  5 13:32:27 1998
+++ propsheet.cc	Thu Dec 20 04:36:03 2001
@@ -0,0 +1,217 @@
+/*
+ * Copyright (c) 2001, Gary R. Van Sickle.
+ *
+ *     This program is free software; you can redistribute it and/or modify
+ *     it under the terms of the GNU General Public License as published by
+ *     the Free Software Foundation; either version 2 of the License, or
+ *     (at your option) any later version.
+ *
+ *     A copy of the GNU General Public License can be found at
+ *     http://www.gnu.org/
+ *
+ * Written by Gary R. Van Sickle <g.r.vansickle@worldnet.att.net>
+ *
+ */
+
+// This is the implementation of the PropSheet class.  This class encapsulates
+// a Windows property sheet / wizard and interfaces with the PropertyPage class.
+// It's named PropSheet instead of PropertySheet because the latter conflicts with
+// the Windows function of the same name.
+
+#include "propsheet.h"
+#include "proppage.h"
+
+//#include <shlwapi.h>
+// ...but since there is no shlwapi.h in mingw yet:
+typedef struct _DllVersionInfo
+{
+  DWORD cbSize;
+  DWORD dwMajorVersion;
+  DWORD dwMinorVersion;
+  DWORD dwBuildNumber;
+  DWORD dwPlatformID;
+}
+DLLVERSIONINFO;
+typedef HRESULT CALLBACK (*DLLGETVERSIONPROC) (DLLVERSIONINFO * pdvi);
+#define PROPSHEETHEADER_V1_SIZE 40
+
+
+
+PropSheet::PropSheet ()
+{
+  NumPropPages = 0;
+}
+
+PropSheet::~PropSheet ()
+{
+}
+
+HPROPSHEETPAGE *
+PropSheet::CreatePages ()
+{
+  HPROPSHEETPAGE *retarray;
+
+  // Create the return array
+  retarray = new HPROPSHEETPAGE[NumPropPages];
+
+  // Create the pages with CreatePropertySheetPage().
+  // We do it here rather than in the PropertyPages themselves
+  // because, for reasons known only to Microsoft, these handles will be
+  // destroyed by the property sheet before the PropertySheet() call returns,
+  // at least if it's modal (don't know about modeless).
+  int i;
+  for (i = 0; i < NumPropPages; i++)
+    {
+      retarray[i] =
+	CreatePropertySheetPage (PropertyPages[i]->GetPROPSHEETPAGEPtr ());
+
+      // Set position info
+      if (i == 0)
+	{
+	  PropertyPages[i]->YouAreFirst ();
+	}
+      else if (i == NumPropPages - 1)
+	{
+	  PropertyPages[i]->YouAreLast ();
+	}
+      else
+	{
+	  PropertyPages[i]->YouAreMiddle ();
+	}
+    }
+
+  return retarray;
+}
+
+static DWORD
+GetPROPSHEETHEADERSize ()
+{
+  // For compatibility with all versions of comctl32.dll, we have to do this.
+
+  DLLVERSIONINFO vi;
+  HMODULE mod;
+  DLLGETVERSIONPROC DllGetVersion;
+  DWORD retval = 0;
+
+
+  // This 'isn't safe' in a DLL, according to MSDN
+  mod = LoadLibrary ("comctl32.dll");
+
+  DllGetVersion = (DLLGETVERSIONPROC) GetProcAddress (mod, "DllGetVersion");
+  if (DllGetVersion == NULL)
+    {
+      // Something's wildly broken, punt.
+      retval = PROPSHEETHEADER_V1_SIZE;
+    }
+  else
+    {
+      vi.cbSize = sizeof (DLLVERSIONINFO);
+      DllGetVersion (&vi);
+
+      if ((vi.dwMajorVersion < 4) ||
+	  ((vi.dwMajorVersion == 4) && (vi.dwMinorVersion < 71)))
+	{
+	  // Recent.
+	  retval = sizeof (PROPSHEETHEADER);
+	}
+      else
+	{
+	  // Old (== Win95/NT4 w/o IE 4 or better)
+	  retval = PROPSHEETHEADER_V1_SIZE;
+	}
+    }
+
+  FreeLibrary (mod);
+
+  return retval;
+}
+
+bool
+PropSheet::Create (const Window * Parent, DWORD Style)
+{
+  PROPSHEETHEADER p;
+
+  PageHandles = CreatePages ();
+
+  p.dwSize = GetPROPSHEETHEADERSize ();
+  p.dwFlags = PSH_NOAPPLYNOW | PSH_WIZARD /*| PSH_MODELESS */ ;
+  if (Parent != NULL)
+    {
+      p.hwndParent = Parent->GetHWND ();
+    }
+  else
+    {
+      p.hwndParent = NULL;
+    }
+  p.hInstance = GetInstance ();
+  p.nPages = NumPropPages;
+  p.nStartPage = 0;
+  p.phpage = PageHandles;
+  p.pfnCallback = NULL;
+
+
+  PropertySheet (&p);
+
+  // Do a modeless property sheet...
+  //SetHWND((HWND)PropertySheet(&p));
+  /*Show(SW_SHOWNORMAL);
+
+     // ...but pretend it's modal
+     MessageLoop();
+     MessageBox(NULL, "DONE", NULL, MB_OK);
+
+     // FIXME: Enable the parent before destroying this window to prevent another window
+     // from becoming the foreground window
+     // ala: EnableWindow(<parent_hwnd>, TRUE);
+     //DestroyWindow(WindowHandle);
+   */
+  SetHWND (NULL);
+
+
+  return true;
+}
+
+void
+PropSheet::SetHWNDFromPage (HWND h)
+{
+  // If we're a modal dialog, there's no way for us to know our window handle unless
+  // one of our pages tells us through this function.
+  SetHWND (h);
+}
+
+void
+PropSheet::AddPage (PropertyPage * p)
+{
+  // Add a page to the property sheet.
+  p->YouAreBeingAddedToASheet (this);
+  PropertyPages[NumPropPages] = p;
+  NumPropPages++;
+}
+
+bool
+PropSheet::SetActivePage (int i)
+{
+  // Posts a message to the message queue, so this won't block
+  return static_cast < bool > (::PropSheet_SetCurSel (GetHWND (), NULL, i));
+}
+
+bool
+PropSheet::SetActivePageByID (int resource_id)
+{
+  // Posts a message to the message queue, so this won't block
+  return static_cast < bool >
+    (::PropSheet_SetCurSelByID (GetHWND (), resource_id));
+}
+
+void
+PropSheet::SetButtons (DWORD flags)
+{
+  // Posts a message to the message queue, so this won't block
+  ::PropSheet_SetWizButtons (GetHWND (), flags);
+}
+
+void
+PropSheet::PressButton (int button)
+{
+  ::PropSheet_PressButton (GetHWND (), button);
+}
Index: propsheet.h
===================================================================
RCS file: propsheet.h
diff -N propsheet.h
--- /dev/null	Tue May  5 13:32:27 1998
+++ propsheet.h	Thu Dec 20 04:36:03 2001
@@ -0,0 +1,59 @@
+#ifndef CINSTALL_PROPSHEET_H
+#define CINSTALL_PROPSHEET_H
+
+/*
+ * Copyright (c) 2001, Gary R. Van Sickle.
+ *
+ *     This program is free software; you can redistribute it and/or modify
+ *     it under the terms of the GNU General Public License as published by
+ *     the Free Software Foundation; either version 2 of the License, or
+ *     (at your option) any later version.
+ *
+ *     A copy of the GNU General Public License can be found at
+ *     http://www.gnu.org/
+ *
+ * Written by Gary R. Van Sickle <g.r.vansickle@worldnet.att.net>
+ *
+ */
+
+// This is the header for the PropSheet class.  This class encapsulates
+// a Windows property sheet / wizard and interfaces with the PropertyPage class.
+// It's named PropSheet instead of PropertySheet because the latter conflicts with
+// the Windows function of the same name.
+
+
+#include <windows.h>
+#include <prsht.h>
+
+#include "window.h"
+
+class PropertyPage;
+
+class PropSheet:public Window
+{
+  PropertyPage *PropertyPages[MAXPROPPAGES];
+  int NumPropPages;
+
+  HPROPSHEETPAGE *PageHandles;
+  HPROPSHEETPAGE *CreatePages ();
+
+public:
+    PropSheet ();
+    virtual ~ PropSheet ();
+
+  // Should be private and friended to PropertyPage
+  void SetHWNDFromPage (HWND h);
+
+  virtual bool Create (const Window * Parent = NULL,
+		       DWORD Style =
+		       WS_OVERLAPPEDWINDOW | WS_VISIBLE | WS_CLIPCHILDREN);
+
+  void AddPage (PropertyPage * p);
+
+  bool SetActivePage (int i);
+  bool SetActivePageByID (int resource_id);
+  void SetButtons (DWORD flags);
+  void PressButton (int button);
+};
+
+#endif // CINSTALL_PROPSHEET_H
Index: res.rc
===================================================================
RCS file: /cvs/src/src/winsup/cinstall/res.rc,v
retrieving revision 2.31
diff -u -p -r2.31 res.rc
--- res.rc	2001/12/03 22:22:09	2.31
+++ res.rc	2001/12/20 12:36:03
@@ -29,7 +29,7 @@ LANGUAGE LANG_ENGLISH, SUBLANG_ENGLISH_U
 //
 
 IDD_SOURCE DIALOG DISCARDABLE  0, 0, 215, 95
-STYLE DS_MODALFRAME | DS_CENTER | WS_POPUP | WS_CAPTION | WS_SYSMENU
+STYLE DS_MODALFRAME | DS_CENTER | WS_CHILD | WS_CAPTION | WS_SYSMENU
 CAPTION "Cygwin Setup"
 FONT 8, "MS Sans Serif"
 BEGIN
@@ -40,26 +40,21 @@ BEGIN
                     BS_AUTORADIOBUTTON,55,30,89,10
     CONTROL         "Install from &Local Directory",IDC_SOURCE_CWD,"Button",
                     BS_AUTORADIOBUTTON,55,45,99,10
-    DEFPUSHBUTTON   "&Next -->",IDOK,100,75,45,15
-    PUSHBUTTON      "Cancel",IDCANCEL,165,75,45,15
 END
 
-IDD_LOCAL_DIR DIALOG DISCARDABLE  0, 0, 215, 95
-STYLE DS_MODALFRAME | DS_CENTER | WS_POPUP | WS_CAPTION | WS_SYSMENU
+IDD_LOCAL_DIR DIALOG DISCARDABLE  0, 0, 227, 94
+STYLE DS_MODALFRAME | DS_CENTER | WS_CHILD | WS_CAPTION | WS_SYSMENU
 CAPTION "Cygwin Setup"
 FONT 8, "MS Sans Serif"
 BEGIN
     ICON            IDI_CYGWIN,IDC_STATIC,5,5,20,20
-    PUSHBUTTON      "B&rowse...",IDC_LOCAL_DIR_BROWSE,150,10,34,14
+    PUSHBUTTON      "B&rowse...",IDC_LOCAL_DIR_BROWSE,185,30,34,14
     LTEXT           "Local Package &Directory",IDC_STATIC,55,15,85,11
-    EDITTEXT        IDC_LOCAL_DIR,55,25,127,12,ES_AUTOHSCROLL
-    DEFPUSHBUTTON   "&Next -->",IDOK,100,75,45,15
-    PUSHBUTTON      "Cancel",IDCANCEL,165,75,45,15
-    PUSHBUTTON      "<-- &Back",IDC_BACK,55,75,45,15
+    EDITTEXT        IDC_LOCAL_DIR,55,30,127,15,ES_AUTOHSCROLL
 END
 
 IDD_ROOT DIALOG DISCARDABLE  0, 0, 215, 95
-STYLE DS_MODALFRAME | DS_CENTER | WS_POPUP | WS_CAPTION | WS_SYSMENU
+STYLE DS_MODALFRAME | DS_CENTER | WS_CHILD | WS_CAPTION | WS_SYSMENU
 CAPTION "Cygwin Setup"
 FONT 8, "MS Sans Serif"
 BEGIN
@@ -77,23 +72,17 @@ BEGIN
                     WS_GROUP,125,60,25,8
     CONTROL         "Just &Me",IDC_ROOT_USER,"Button",BS_AUTORADIOBUTTON,160,
                     60,50,8
-    DEFPUSHBUTTON   "&Next -->",IDOK,100,75,45,15
-    PUSHBUTTON      "Cancel",IDCANCEL,165,75,45,15
-    PUSHBUTTON      "<-- &Back",IDC_BACK,55,75,45,15
 END
 
-IDD_SITE DIALOG DISCARDABLE  0, 0, 222, 206
-STYLE DS_MODALFRAME | DS_CENTER | WS_POPUP | WS_CAPTION | WS_SYSMENU
+IDD_SITE DIALOG DISCARDABLE  0, 0, 247, 94
+STYLE DS_MODALFRAME | DS_CENTER | WS_CHILD | WS_CAPTION | WS_SYSMENU
 CAPTION "Cygwin Setup"
 FONT 8, "MS Sans Serif"
 BEGIN
     ICON            IDI_CYGWIN,IDC_STATIC,5,5,20,20
-    LTEXT           "Select Download &Sites",IDC_STATIC,55,5,135,11
-    LISTBOX         IDC_URL_LIST,55,20,160,155,LBS_NOINTEGRALHEIGHT | 
-    		    LBS_EXTENDEDSEL | WS_VSCROLL | WS_HSCROLL | WS_TABSTOP
-    DEFPUSHBUTTON   "&Next -->",IDOK,105,185,45,15
-    PUSHBUTTON      "Cancel",IDCANCEL,170,185,45,15
-    PUSHBUTTON      "<-- &Back",IDC_BACK,60,185,45,15
+    LTEXT           "Select Download &Site",IDC_STATIC,55,5,135,11
+    LISTBOX         IDC_URL_LIST,55,20,185,65,LBS_NOINTEGRALHEIGHT | 
+                    LBS_EXTENDEDSEL | WS_VSCROLL | WS_HSCROLL | WS_TABSTOP
 END
 
 IDD_OTHER_URL DIALOG DISCARDABLE  0, 0, 215, 95
@@ -109,32 +98,31 @@ BEGIN
     PUSHBUTTON      "<-- &Back",IDC_BACK,55,75,45,15
 END
 
-IDD_NET DIALOGEX 0, 0, 215, 95
-STYLE DS_MODALFRAME | DS_CENTER | WS_POPUP | WS_CAPTION | WS_SYSMENU
+IDD_NET DIALOG DISCARDABLE  0, 0, 247, 106
+STYLE DS_MODALFRAME | DS_CENTER | WS_CHILD | WS_CAPTION | WS_SYSMENU
 CAPTION "Cygwin Setup"
 FONT 8, "MS Sans Serif"
 BEGIN
-    ICON            IDI_CYGWIN,IDC_STATIC,5,5,20,20
     CONTROL         "&Direct Connection",IDC_NET_DIRECT,"Button",
-                    BS_AUTORADIOBUTTON,55,10,73,10
+                    BS_AUTORADIOBUTTON | WS_GROUP | WS_TABSTOP,55,10,73,10
     CONTROL         "Use &IE5 Settings",IDC_NET_IE5,"Button",
-                    BS_AUTORADIOBUTTON,55,25,69,10
+                    BS_AUTORADIOBUTTON | WS_TABSTOP,55,25,69,10
     CONTROL         "Use HTTP/FTP &Proxy:",IDC_NET_PROXY,"Button",
-                    BS_AUTORADIOBUTTON,55,40,88,10
-    LTEXT           "Proxy &Host",IDC_STATIC,10,55,50,15,SS_CENTERIMAGE,
-                    WS_EX_RIGHT
-    EDITTEXT        IDC_PROXY_HOST,65,55,80,12,ES_AUTOHSCROLL | WS_DISABLED
-    LTEXT           "Por&t",IDC_STATIC,155,55,20,15,SS_CENTERIMAGE,
-                    WS_EX_RIGHT
-    EDITTEXT        IDC_PROXY_PORT,180,55,30,12,ES_AUTOHSCROLL | WS_DISABLED
-    DEFPUSHBUTTON   "&Next -->",IDOK,100,75,45,15
-    PUSHBUTTON      "Cancel",IDCANCEL,165,75,45,15
-    PUSHBUTTON      "<-- &Back",IDC_BACK,55,75,45,15
+                    BS_AUTORADIOBUTTON | WS_TABSTOP,55,40,88,10
+    EDITTEXT        IDC_PROXY_HOST,115,60,120,12,ES_AUTOHSCROLL | 
+                    WS_DISABLED | WS_GROUP
+    EDITTEXT        IDC_PROXY_PORT,115,80,30,12,ES_AUTOHSCROLL | WS_DISABLED
+    GROUPBOX        "",IDC_STATIC,55,50,185,50
+    ICON            IDI_CYGWIN,IDC_STATIC,5,5,21,20
+    RTEXT           "Proxy &Host",IDC_STATIC,60,60,50,12,SS_CENTERIMAGE | 
+                    NOT WS_GROUP
+    RTEXT           "Por&t",IDC_STATIC,80,80,30,12,SS_CENTERIMAGE | NOT 
+                    WS_GROUP
 END
 
 IDD_DLSTATUS DIALOG DISCARDABLE  0, 0, 215, 95
-STYLE DS_MODALFRAME | DS_SETFOREGROUND | DS_CENTER | WS_POPUP | WS_VISIBLE | 
-    WS_CAPTION | WS_SYSMENU
+STYLE DS_MODALFRAME | DS_CENTER | WS_CHILD | WS_VISIBLE | WS_CAPTION | 
+    WS_SYSMENU
 CAPTION "Cygwin Setup"
 FONT 8, "MS Sans Serif"
 BEGIN
@@ -154,26 +142,25 @@ BEGIN
     RTEXT           "Disk",IDC_DLS_IPROGRESS_TEXT,5,60,45,8
 END
 
-IDD_INSTATUS DIALOG DISCARDABLE  0, 0, 215, 95
-STYLE DS_MODALFRAME | DS_SETFOREGROUND | DS_CENTER | WS_POPUP | WS_VISIBLE | 
-    WS_CAPTION | WS_SYSMENU
+IDD_INSTATUS DIALOG DISCARDABLE  0, 0, 252, 94
+STYLE DS_MODALFRAME | DS_CENTER | WS_CHILD | WS_VISIBLE | WS_CAPTION | 
+    WS_SYSMENU
 CAPTION "Cygwin Setup"
 FONT 8, "MS Sans Serif"
 BEGIN
-    ICON            IDI_CYGWIN,IDC_STATIC,5,5,20,20
-    PUSHBUTTON      "Cancel",IDCANCEL,165,75,45,15
+    ICON            IDI_CYGWIN,IDC_STATIC,5,5,21,20
     LTEXT           "Installing...",IDC_INS_ACTION,55,5,135,8
     LTEXT           "(PKG)",IDC_INS_PKG,55,15,150,8
     LTEXT           "(FILE)",IDC_INS_FILE,55,25,155,8
     CONTROL         "Progress1",IDC_INS_DISKFULL,"msctls_progress32",
-                    PBS_SMOOTH | WS_BORDER,55,60,155,10
+                    PBS_SMOOTH | WS_BORDER,90,60,155,10
     CONTROL         "Progress1",IDC_INS_IPROGRESS,"msctls_progress32",
-                    PBS_SMOOTH | WS_BORDER,55,50,155,10
+                    PBS_SMOOTH | WS_BORDER,90,50,155,10
     CONTROL         "Progress1",IDC_INS_PPROGRESS,"msctls_progress32",
-                    PBS_SMOOTH | WS_BORDER,55,40,155,10
-    RTEXT           "Package",IDC_STATIC,5,40,45,8
-    RTEXT           "Total",IDC_STATIC,10,50,40,8
-    RTEXT           "Disk",IDC_STATIC,5,60,45,8
+                    PBS_SMOOTH | WS_BORDER,90,40,155,10
+    RTEXT           "Package",IDC_INS_BL_PACKAGE,40,40,45,8
+    RTEXT           "Total",IDC_INS_BL_TOTAL,45,50,40,8
+    RTEXT           "Disk",IDC_INS_BL_DISK,40,60,45,8
 END
 
 IDD_PROXY_AUTH DIALOG DISCARDABLE  0, 0, 215, 95
@@ -210,8 +197,9 @@ BEGIN
     PUSHBUTTON      "Cancel",IDCANCEL,165,75,45,15
 END
 
-IDD_SPLASH DIALOG DISCARDABLE  0, 0, 215, 95
-STYLE DS_MODALFRAME | DS_CENTER | WS_POPUP | WS_CAPTION | WS_SYSMENU
+IDD_SPLASH DIALOG DISCARDABLE  0, 0, 216, 94
+STYLE DS_MODALFRAME | DS_3DLOOK | DS_CENTER | WS_CHILD | WS_VISIBLE | 
+    WS_CAPTION | WS_SYSMENU
 CAPTION "Cygwin Setup"
 FONT 8, "MS Sans Serif"
 BEGIN
@@ -223,17 +211,26 @@ BEGIN
                     8
     LTEXT           "http://sources.redhat.com/cygwin/",IDC_STATIC,55,50,112,
                     8
-    DEFPUSHBUTTON   "&Next -->",IDOK,100,75,45,15
-    PUSHBUTTON      "Cancel",IDCANCEL,165,75,45,15
 END
 
-IDD_CHOOSE DIALOG DISCARDABLE  0, 0, 429, 266
-STYLE DS_MODALFRAME | DS_3DLOOK | DS_CENTER | WS_POPUP | WS_CAPTION | 
-    WS_SYSMENU
+IDD_CHOOSE DIALOGEX 0, 0, 430, 266
+STYLE DS_MODALFRAME | DS_3DLOOK | DS_CENTER | WS_CHILD | WS_VISIBLE | 
+    WS_CAPTION | WS_SYSMENU
+EXSTYLE WS_EX_CONTROLPARENT
 CAPTION "Cygwin Setup"
 FONT 8, "MS Sans Serif"
 BEGIN
-    ICON            IDI_CYGWIN,IDC_STATIC,0,2,21,20
+    DEFPUSHBUTTON   "&Next -->",IDOK,311,242,45,15,WS_GROUP
+    PUSHBUTTON      "Cancel",IDCANCEL,375,242,45,15
+    PUSHBUTTON      "<-- &Back",IDC_BACK,266,242,45,15
+    CONTROL         "&Prev",IDC_CHOOSE_PREV,"Button",BS_AUTORADIOBUTTON | 
+                    WS_GROUP | WS_TABSTOP,265,5,27,10
+    CONTROL         "&Curr",IDC_CHOOSE_CURR,"Button",BS_AUTORADIOBUTTON,297,
+                    5,25,10
+    CONTROL         "E&xp",IDC_CHOOSE_EXP,"Button",BS_AUTORADIOBUTTON,323,5,
+                    25,10
+    PUSHBUTTON      "&View",IDC_CHOOSE_VIEW,353,5,20,10,WS_GROUP
+    ICON            IDI_CYGWIN,IDC_STATIC,0,2,20,20
     LTEXT           "Select packages to install",IDC_CHOOSE_INST_TEXT,125,5,
                     99,8
     CONTROL         "",IDC_LISTVIEW_POS,"Static",SS_BLACKFRAME | NOT 
@@ -241,21 +238,12 @@ BEGIN
     CONTROL         "SPIN",IDC_STATIC,"Static",SS_BITMAP,22,235,15,13
     LTEXT           "= click to choose action, (p) = previous version, (x) = experimental",
                     IDC_STATIC,35,234,220,8
-    PUSHBUTTON      "&View",IDC_CHOOSE_VIEW,353,5,20,10
     LTEXT           "",IDC_CHOOSE_VIEWCAPTION,390,5,30,10
-    CONTROL         "E&xp",IDC_CHOOSE_EXP,"Button",BS_AUTORADIOBUTTON | 
-                    WS_GROUP,323,5,25,10
-    CONTROL         "&Prev",IDC_CHOOSE_PREV,"Button",BS_AUTORADIOBUTTON,265,
-                    5,27,10
-    CONTROL         "&Curr",IDC_CHOOSE_CURR,"Button",BS_AUTORADIOBUTTON,297,
-                    5,25,10
-    DEFPUSHBUTTON   "&Next -->",IDOK,311,242,45,15
-    PUSHBUTTON      "Cancel",IDCANCEL,375,242,45,15
-    PUSHBUTTON      "<-- &Back",IDC_BACK,266,242,45,15
 END
 
 IDD_DESKTOP DIALOG DISCARDABLE  0, 0, 215, 95
-STYLE DS_MODALFRAME | DS_CENTER | WS_POPUP | WS_CAPTION | WS_SYSMENU
+STYLE DS_MODALFRAME | DS_3DLOOK | DS_CENTER | WS_CHILD | WS_VISIBLE | 
+    WS_CAPTION | WS_SYSMENU
 CAPTION "Cygwin Setup"
 FONT 8, "MS Sans Serif"
 BEGIN
@@ -264,12 +252,9 @@ BEGIN
                     BS_AUTOCHECKBOX,55,25,100,8
     CONTROL         "Add to &Start Menu",IDC_ROOT_MENU,"Button",
                     BS_AUTOCHECKBOX,55,40,100,8
-    DEFPUSHBUTTON   "&Next -->",IDOK,100,75,45,15
-    PUSHBUTTON      "Cancel",IDCANCEL,165,75,45,15
-    PUSHBUTTON      "<-- &Back",IDC_BACK,55,75,45,15
 END
 
-IDD_FTP_AUTH DIALOGEX 0, 0, 215, 95
+IDD_FTP_AUTH DIALOG DISCARDABLE  0, 0, 215, 95
 STYLE DS_MODALFRAME | DS_CENTER | WS_POPUP | WS_CAPTION | WS_SYSMENU
 CAPTION "Cygwin Setup"
 FONT 8, "MS Sans Serif"
@@ -286,7 +271,16 @@ BEGIN
     PUSHBUTTON      "Cancel",IDCANCEL,165,75,45,15
 END
 
+IDD_CHOOSER DIALOG DISCARDABLE  0, 0, 186, 90
+STYLE DS_MODALFRAME | DS_3DLOOK | WS_CHILD | WS_VISIBLE | WS_CAPTION | 
+    WS_SYSMENU
+CAPTION "Cygwin Setup"
+FONT 8, "MS Sans Serif"
+BEGIN
+    LTEXT           "Don't look here",IDC_STATIC,25,38,134,8
+END
 
+
 #ifdef APSTUDIO_INVOKED
 /////////////////////////////////////////////////////////////////////////////
 //
@@ -339,9 +333,21 @@ CYGWIN.ICON             FILE    DISCARDA
 #ifdef APSTUDIO_INVOKED
 GUIDELINES DESIGNINFO DISCARDABLE 
 BEGIN
+    IDD_LOCAL_DIR, DIALOG
+    BEGIN
+        RIGHTMARGIN, 215
+    END
+
+    IDD_SITE, DIALOG
+    BEGIN
+        RIGHTMARGIN, 215
+        BOTTOMMARGIN, 93
+    END
+
     IDD_NET, DIALOG
     BEGIN
-        BOTTOMMARGIN, 49
+        RIGHTMARGIN, 215
+        BOTTOMMARGIN, 60
     END
 
     IDD_PROXY_AUTH, DIALOG
@@ -354,10 +360,23 @@ BEGIN
         BOTTOMMARGIN, 49
     END
 
+    IDD_CHOOSE, DIALOG
+    BEGIN
+        RIGHTMARGIN, 429
+    END
+
     IDD_FTP_AUTH, DIALOG
     BEGIN
         BOTTOMMARGIN, 49
     END
+
+    IDD_CHOOSER, DIALOG
+    BEGIN
+        LEFTMARGIN, 7
+        RIGHTMARGIN, 179
+        TOPMARGIN, 7
+        BOTTOMMARGIN, 83
+    END
 END
 #endif    // APSTUDIO_INVOKED
 
@@ -409,6 +428,7 @@ BEGIN
     IDS_DOWNLOAD_FAILED     "Unable to download %s"
     IDS_DOWNLOAD_INCOMPLETE "Download Incomplete.  Try again?"
     IDS_INSTALL_INCOMPLETE  "Installation incomplete.  Check /setup.log.full for details"
+    IDS_VERSION_INFO        "Setup.exe version %1"
 END
 
 #endif    // English (U.S.) resources
Index: resource.h
===================================================================
RCS file: /cvs/src/src/winsup/cinstall/resource.h,v
retrieving revision 2.13
diff -u -p -r2.13 resource.h
--- resource.h	2001/12/20 11:49:54	2.13
+++ resource.h	2001/12/20 12:36:03
@@ -27,6 +27,7 @@
 #define IDS_DOWNLOAD_FAILED             25
 #define IDS_DOWNLOAD_INCOMPLETE         26
 #define IDS_INSTALL_INCOMPLETE          27
+#define IDS_VERSION_INFO                28
 #define IDD_ROOT                        101
 #define IDD_SOURCE                      102
 #define IDD_OTHER_URL                   103
@@ -53,6 +54,7 @@
 #define IDB_CHECK_NO                    124
 #define IDB_CHECK_NA                    125
 #define IDD_FTP_AUTH                    126
+#define IDD_CHOOSER                     127
 #define IDC_SOURCE_DOWNLOAD             1000
 #define IDC_SOURCE_NETINST              1001
 #define IDC_SOURCE_CWD                  1002
@@ -99,9 +101,12 @@
 #define IDC_DLS_PROGRESS_TEXT           1047
 #define IDC_DLS_PPROGRESS_TEXT          1048
 #define IDC_DLS_IPROGRESS_TEXT          1049
-#define IDC_CHOOSE_INST_TEXT      1050
+#define IDC_CHOOSE_INST_TEXT            1050
 #define IDC_CHOOSE_VIEWCAPTION          1051
 #define IDC_CHOOSE_LISTHEADER		1052
+#define IDC_INS_BL_PACKAGE              1053
+#define IDC_INS_BL_TOTAL                1054
+#define IDC_INS_BL_DISK                 1055
 #define IDC_STATIC                      -1
 
 // Next default values for new objects
@@ -110,9 +115,9 @@
 #ifndef APSTUDIO_READONLY_SYMBOLS
 #define _APS_NO_MFC                     1
 #define _APS_3D_CONTROLS                     1
-#define _APS_NEXT_RESOURCE_VALUE        127
+#define _APS_NEXT_RESOURCE_VALUE        128
 #define _APS_NEXT_COMMAND_VALUE         40003
-#define _APS_NEXT_CONTROL_VALUE         1053
+#define _APS_NEXT_CONTROL_VALUE         1056
 #define _APS_NEXT_SYMED_VALUE           101
 #endif
 #endif
